Unit qss2e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS12_p;

procedure qss2e(var RINT :Array of Extended; A :Extended;
                B :Extended; F :Proc_F3E_A; N :Integer; EPS :Extended;
                K :Integer; var IND :Array of Integer;
                var R :Array of Extended; var IERR :Integer);

implementation

procedure qss2e(var RINT :Array of Extended; A :Extended;
                B :Extended; F :Proc_F3E_A; N :Integer; EPS :Extended;
                K :Integer; var IND :Array of Integer;
                var R :Array of Extended; var IERR :Integer);
var
I,J,J1,K1,K2 :Integer;
E,H,H1,S :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90;
begin
IERR := 0;
for I:=1 to N do
 begin
  R[(I-1)+2*N] := 0.e0;
  IND[I-1] := 0;
_10:
 end;
K1 := K;
if ( K  <=  0 ) 
 then K1 := 1;
H := (B - A)/K1*0.5e0;
F(A,RINT,IND);
F(B,R,IND);
for I:=1 to N do
 begin
  R[(I-1)+1*N] := (RINT[I-1] + R[(I-1)+0*N])*H;
  RINT[I-1] := R[(I-1)+1*N]/3.e0;
_20:
 end;
K1 := K1 + K1 - 1;
J1 := -1;
for J:=1 to K1 do
 begin
  F(A + J*H,R,IND);
  J1 := -1*J1;
  for I:=1 to N do
   begin
    RINT[I-1] := RINT[I-1] + (3.e0 + J1)*R[(I-1)+0*N]*H/3.e0;
    R[(I-1)+1*N] := R[(I-1)+1*N] + R[(I-1)+0*N]*2.e0*H;
_30:
   end;
_40:
 end;
if ( EPS  <=  0.e0 ) 
 then goto _90;
K1 := K1 + 1;
_50:
H1 := H*0.5e0;
for J:=1 to K1 do
 begin
  F(A + (2.e0*J - 1.e0)*H1,R,IND);
  for I:=1 to N do
   begin
    R[(I-1)+2*N] := R[(I-1)+2*N] + R[(I-1)+0*N];
_60:
   end;
_70:
 end;
K2 := 1;
for I:=1 to N do
 begin
  if ( IND[I-1]  >  0 ) 
   then goto _80;
  S := (R[(I-1)+1*N] + 4.e0*H*R[(I-1)+2*N])/6.e0;
  E := Abs(RINT[I-1] - S)/(1.e0 + Abs(S));
  RINT[I-1] := S;
  if ( E  <=  EPS ) 
   then IND[I-1] := K1 div 2;
  R[(I-1)+1*N] := 0.5e0*R[(I-1)+1*N] + R[(I-1)+2*N]*H;
  R[(I-1)+2*N] := 0.e0;
  if ( IND[I-1]  =  0 ) 
   then K2 := 0;
_80:
 end;
if ( K2  >  0 ) 
 then goto _90;
K1 := K1 + K1;
H := H*0.5e0;
if ( K1  <=  1048576 ) 
 then goto _50;
IERR := 65;
UTQS12(IERR,9);
_90:
end;

end.
